SystemOrganization addCategory: #J!

!ByteString methodsFor: '*J' stamp: 'HwaJong 12/24/2012 22:09'!
compileJ
	 '?. 20 $ 100' = self ifTrue: [^((Random new next: 20) * 100) collect: #truncated].
	^self substrings.! !

!Matrix methodsFor: '*J' stamp: 'HwaJong 12/24/2012 22:35'!
collectJ: anArray rank: aSmallInteger 
	^self rows collect: [:each| anArray doJ: each]! !

!Array methodsFor: '*J' stamp: 'HwaJong 1/5/2014 23:06'!
collectForMulitCollection: aBlockClosure 
	^self collect: [ :each|  each collectForMulitCollection: aBlockClosure  ] ! !

!Array methodsFor: '*J' stamp: 'HwaJong 12/24/2012 22:07'!
doJ: anArray 
	| coll |
	coll := self collect: [:op| (op beginsWith: '#') ifTrue: [anArray perform: op allButFirst asSymbol  ] ifFalse: [op]].
	^coll second = '/'
		ifTrue: [coll first / coll third]
		ifFalse: [coll]! !

Object subclass: #JTensor
	uses: ClassCheckingHashProofTrait
	instanceVariableNames: 'dimension contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'J'!

JTensor class
	uses: ClassCheckingHashProofTrait classTrait
	instanceVariableNames: ''!

!JTensor class methodsFor: 'instance creation' stamp: 'HwaJong 12/25/2012 23:14'!
dimension: array1 contents: array2
	^self new 
		dimension: array1;
		contents: array2.! !

!JTensor class methodsFor: 'instance creation' stamp: 'HwaJong 8/29/2013 15:04'!
dimension: anArray randomInt: anInteger
	^self dimension: anArray randomInt: anInteger withRandom: Random new.
! !

!JTensor class methodsFor: 'instance creation' stamp: 'HwaJong 8/29/2013 15:04'!
dimension: anArray randomInt: anInteger withRandom: aRandom 
	^self new dimension: anArray; contents: (anArray product timesCollect: [aRandom nextInt: anInteger]).! !

!JTensor class methodsFor: 'instance creation' stamp: 'HwaJong 12/25/2012 01:12'!
i: anArray 
	^self new dimension: anArray; contents: (0 to: anArray product-1)! !

!JTensor methodsFor: 'accessing' stamp: 'HwaJong 12/25/2012 22:39'!
at: anArray
	|mq |
	mq := MultiQuoAndRem new.
	mq dividers: dimension.
	^contents at: (mq unIndexValue: anArray).! !

!JTensor methodsFor: 'enumerating' stamp: 'HwaJong 12/25/2012 01:22'!
collect: aBlockClosure
	^self class new
		dimension: dimension copy;
		contents: (contents collect: aBlockClosure)  
	! !

!JTensor methodsFor: 'accessing' stamp: 'HwaJong 12/25/2012 01:00'!
contents
	^ contents! !

!JTensor methodsFor: 'accessing' stamp: 'HwaJong 12/24/2012 22:41'!
contents: aSequenceableCollection 
	contents := aSequenceableCollection! !

!JTensor methodsFor: 'accessing' stamp: 'HwaJong 12/25/2012 01:00'!
dimension
	^ dimension! !

!JTensor methodsFor: 'accessing' stamp: 'HwaJong 12/24/2012 22:40'!
dimension: anArray 
	dimension := anArray! !

!JTensor methodsFor: 'private' stamp: 'HwaJong 12/25/2012 01:00'!
gettersForEquality
	^#(dimension contents)! !

!JTensor methodsFor: 'testing' stamp: 'HwaJong 12/24/2012 22:41'!
isDimensionCorrect
	^dimension product = contents size! !

!JTensor methodsFor: 'self evaluating' stamp: 'HwaJong 8/29/2013 15:26'!
rank: rankInteger 
	|elementDimension streams mq|
	elementDimension := (dimension copyFrom: 1 to: rankInteger-1), (dimension copyFrom: rankInteger+1 to: dimension size).
	mq := MultiQuoAndRem new.
	mq dividers: dimension.
	streams := (dimension at: rankInteger) timesCollect: [MQARArrayWritter onArrayOfSize: elementDimension product].
	contents keysAndValuesDo: [:k :v| 
		(streams at: (((mq value: k-1) at: 1+rankInteger)+1)) nextPut: v ].
	^streams collect: [:st| JTensor new dimension: elementDimension copy; contents: st array]! !

!JTensor methodsFor: 'self evaluating' stamp: 'HwaJong 12/25/2012 01:28'!
sum
	^contents sum! !

Object subclass: #JVerb
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'J'!

!Object methodsFor: '*J' stamp: 'HwaJong 1/5/2014 23:06'!
collectForMulitCollection: aBlockClosure 
	^aBlockClosure value: self ! !

TestCase subclass: #JTensorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'J'!

!JTensorTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/25/2012 23:32'!
testAt
	| t |
	t := JTensor dimension: {2. 3. 2} contents: (1 to: 12).
	self assert: (t at: {1. 1. 1}) equals: 1.
	self assert: (t at: {1. 2. 2}) equals: 4.
	self assert: (t at: {2. 3. 2}) equals: 12.! !

!JTensorTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/25/2012 23:11'!
testCollect
	self assert: 
		((JTensor new dimension: {3. 2}; contents: (1 to: 6)) collect: [:each| each * 5]) 
		equals: 
		(JTensor new dimension: {3. 2}; contents: (5 to: 30 by: 5)) ! !

!JTensorTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 15:08'!
testDimensionRandomInt
	self assert: (JTensor dimension: #(4 5) randomInt: 50 withRandom: (Random seed: 1299)) equals:
		(JTensor dimension: #(4 5) contents: #(1 44 27 40 4 22 6 43 21 9 9 37 22 46 23 5 42 50 3 42) )! !

!JTensorTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/29/2013 15:20'!
testEqual

	self assert: (JTensor dimension: #(4 3) contents: (1 to: 12)) = (JTensor dimension: #(4 3) contents: (1 to: 12)).
	self deny: (JTensor dimension: #(3 4) contents: (1 to: 12)) = (JTensor dimension: #(4 3) contents: (1 to: 12)).
	self deny: (JTensor dimension: #(4 3) contents: (0 to: 11)) = (JTensor dimension: #(4 3) contents: (1 to: 12)).! !

!JTensorTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/25/2012 23:28'!
testI
	self assert: (JTensor i: {2. 3}) equals: (JTensor dimension: {2. 3} contents: {0. 1. 2. 3. 4. 5})! !

!JTensorTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/25/2012 23:09'!
testIsDimensionCorrect
	self assert: (JTensor new dimension: #(4 3); contents: (1 to: 12)) isDimensionCorrect.
	self deny: (JTensor new dimension: #(4 3); contents: (1 to: 10)) isDimensionCorrect! !

!JTensorTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/25/2012 23:25'!
testRank
	| t |
	t := JTensor dimension: {2. 3. 2} contents: (1 to: 12).
	self assert: (t rank: 1) equals: 
		{JTensor dimension: {3. 2} contents: (1 to: 6). 
		JTensor dimension: {3. 2} contents: (7 to: 12)}.
	self assert: (t rank: 2) equals: 
		{JTensor dimension: {2. 2} contents: {1. 2. 7. 8}. 
		JTensor dimension: {2. 2} contents: {3. 4. 9. 10}. 
		JTensor dimension: {2. 2} contents: {5. 6. 11. 12}}.
	self assert: (t rank: 3) equals: 
		{JTensor dimension: {2. 3} contents: {1. 3. 5. 7. 9. 11}. 
		JTensor dimension: {2. 3} contents: {2. 4. 6. 8. 10. 12}}.
! !

!JTensorTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/25/2012 23:29'!
testSum
	self assert: (JTensor dimension: {1. 3} contents: {4. 6. 5}) sum equals: 15! !
